<?php

/**
 * 
 * 2009-08-24 template_directReply.php
 *
 * @author Mariusz Chwalba <koder@mediasystems.pl>
 * @copyright 2009 Media Systems
 * @package cashbill
 * 
 * @page templates Gotowe Szablony
 * @section template_directReply Bezpośrednia odpowiedź na SMS
 * 
 * Ten szablon powinien być stosowany dla usług, w których klient po wysłaniu SMS bezzwłocznie otrzymuje określoną przez
 * partnera odpowiedź. Partner otrzymuje wszystkie informacje o SMS wysłanym przez klienta, decyduje o treści
 * odpowiedzi i bezzwłocznie odsyła ją do klienta.
 * 
 * Szablon zawarty jest w pliku template_100_directReply.php. Zalecamy skopiowanie treści szablonu do
 * pliku index.php i wprowadzenie własnej obsługi wiadomości w wyznaczonym miejscu.
 * 
 * Wymagane ingerencje w treść zaznaczone są ciągami znaków todo.
 *
 */

require_once 'smsGatewaySoap/cashbillSms.php';
require_once 'smsGatewaySoap/messageLogger.php';

class cSMSDirectReply implements iSmsHandler 
{
	function handle( cMessageSMSIn $sms )
	{
		
		/*
		 * @todo: dodać określenie odpowiedzi, która powinna zostać odesłana do klienta
		 * 
		 * Treść przysłanej wiadomości znajduje się w $sms->text
		 * 
		 * Szczegółowe dane o wysłanej wiadomości (numer klienta, czas wysłania, identyfikatory)
		 * udokumentowane są w klasie cMessageSMSIn.
		 * 
		 */
		$odpowiedz = 'Z telefonu: '. $sms->msisdn .' przyszła treść: '.$sms->text;
		
		$sms->reply( $odpowiedz )->send(); // korzystanie z metody "reply" zapewnia automatyczne przydzielenie unikalnego identyfikatora, wymaganego przez system Cashbill
		
	}
	
}

/*
 * @todo: uzupełnić klucz tajny i prefiks (identyfikator usługi).
 * Dane te można odczytać z panelu administracyjnego Cashbill, po
 * wybraniu zatwierdzonej usługi SMS.
 * 
 */
$smsGateway = new cGateway( '<twoj klucz tajny>', '<prefiks usługi>' );

/*
 * Poniżej znajduje się sekcja uruchamiająca loggery diagnostyczne,
 * zapisujące wszystkie informacje o transmisji SMS do pliku
 * (domyślnie log/sms.log). Loggery można usunąć bez wpływu na działanie
 * systemu, jednak zalecamy pozostawienie ich w celach diagnostycznych.
 * 
 *  @todo: zdecydować, czy logowanie jest potrzebne
 */
$smsGateway->addReportHandler  ( new cReportLogger()   );
$smsGateway->addSMSHandler     ( new cSMSLogger()      );
$smsGateway->addSMSErrorHandler( new cSMSErrorLogger() );

/*
 * Poniższa sekcja uruchamia właściwą obsługę wiadomości SMS.
 */
$smsGateway->addSMSHandler( new cSMSDirectReply() );
$smsGateway->handleInput();


?>